import React, { useState, useEffect } from 'react';
import { Card, Checkbox } from 'antd';
import apis from '../../services/apis';
import request from '../../utils/request'

const { Meta } = Card;

/**
 *
 *
 * @param {*} props
 * @returns
 */
const PosterCard = (props) => {
  const [ data, setData ] = useState([])
//   const [ checkedData, setCheckedData ] = useState([])

  useEffect(() => {
    getCardsList(props.postType);    
  },[])


  const getCardsList = (postType) => {
    request({ ...apis.poster.posterTemplate, params: { type: postType }}).then((data) => {
        setData(data)
      }).catch((err) => {
        message.info(err.msg || err.message)
      })
  }

  const onChange = (template) => (e) => {
    // debugger

    if (e.target.checked) {
        if (props.checkedList.indexOf(template.templateId) > -1) {
            props.onChange(props.checkedList)
        } else {
            props.onChange(props.checkedList.concat(template.templateId))
        }
    } else {
        props.onChange(props.checkedList.filter(x => x !== template.templateId))
    }
  }

  return (
      data.map(template => (
        <Card
            hoverable
            style={{ width: 240 }}
            cover={<img src={template.img} />}
        >

        <Checkbox checked={props.checkedList.indexOf(template.templateId) !== -1} onChange={onChange(template)}>生成海分享给朋友</Checkbox>

        </Card>
      ))
  )
}
export default PosterCard

