import React, { useState, useEffect } from 'react'
import { Upload, Button, Icon } from 'antd';
import { uploaderProps } from '../../utils/upload';

function fileUpload(props) {

  const { value } = props
  console.log('fileUploadProps： ', props)
  // eslint-disable-next-line react-hooks/rules-of-hooks
  const [defaultFileList, setDefaultFileList] = useState([])

  // eslint-disable-next-line react-hooks/rules-of-hooks
  useEffect(() => {
    setDefaultValue()
  }, [props.value]);


  function getFileList() {
    return (value || []).map((img, inx) => ({ uid: inx, url: img, name: img.substring(img.lastIndexOf('/') + 1, img.length), status: 'done' }))
  }

  function setDefaultValue() {
    if (!value) {
      return;
    }

    setDefaultFileList(getFileList())
  }

  function onFileChange({ file, fileList }) {
    setDefaultFileList(fileList)
    if (file.status === 'uploading') {
      return
    }

    if (file.status === 'done') {
      props.onChange([].concat(file.response))
    }
  }

  return (
    <>
      <Upload
        { ...uploaderProps }
        {...props}
        onChange={onFileChange}
        fileList={defaultFileList}
      >
        <Button>
          <Icon type="upload" /> {props.label}
        </Button>
      </Upload>
    </>
  )
}

export default fileUpload
